P2J.modules.home=function(){
	var home=$('#home');
	var pictURL=$('#home #pictURL');
	var sounds=$('#home #sounds');
	var slide=null;
	var showBackgroundImage=$('#home #showBackgroundImage');
	var rows=$('#home #rows');
	var cols=$('#home #cols');
	var rotations=$('#home #rotations');
	var photo=$('#home #photo');
	var gallery=$('#home #gallery');
	var language=$('#home #language');

	var puzzleChange=function(e,dontSaveData){
		var data={
			pictURL : pictURL.val(),
			rows : rows.val(),
			cols : cols.val(),
			rotations : rotations.val()
		}
		$(window).trigger('puzzleChange',data);
		if(dontSaveData)return;
		P2J.set(data);
	};
	
	var configChange=function(e,dontSaveData){
		var data={
			showBackgroundImage : showBackgroundImage.is(':checked'),
			sounds : sounds.is(':checked')
		}
		$(window).trigger('configChange',data);	
		if(dontSaveData)return;
		P2J.set({
			sounds : sounds.is(':checked')?sounds.val():'',
			showBackgroundImage : showBackgroundImage.is(':checked')?showBackgroundImage.val():''
		});
	};
	
	var getPhoto=function(sourceType){
		navigator.camera.getPicture(function(imageData){
			pictURL.val(imageData);
			puzzleChange();
		}, $.noop , {
			allowEdit: true,
			sourceType:sourceType,
			correctOrientation:true,
			destinationType : Camera.DestinationType.FILE_URI
		});
	};
	
	var makePhoto=function(){
		if(window.Camera) getPhoto(Camera.PictureSourceType.CAMERA);
		else alert('Not available for desktop');
	};
	
	var selectPhoto=function(){
		if(window.Camera) getPhoto(Camera.PictureSourceType.PHOTOLIBRARY);
		else alert('Not available for desktop');
	};
	
	var languageChange=function(event){
		P2J.set("language",event.target?$(event.target).val():event);
		i18n.selectLanguage(P2J.get("language"));
		
		$('#home label[for="rows"]').text(i18n.lang.rows+":");
		for(var i=2;i<11;i++) rows[0].options[i-2].text=i+' '+i18n.lang.rows;
		rows.selectmenu().selectmenu("refresh");
		
		$('#home label[for="cols"]').text(i18n.lang.cols+":");
		for(var i=2;i<11;i++) cols[0].options[i-2].text=i+' '+i18n.lang.cols;
		cols.selectmenu().selectmenu("refresh");
		
		$('#home label[for="rotations"]').text(i18n.lang.rotations.text+":");
		for(var i=0;i<5;i++) rotations[0].options[i].text=i18n.lang.rotations.options[i];
		rotations.selectmenu().selectmenu("refresh");
		
		$('#home legend[for="language"]').text(i18n.lang.options.language+":");
		$('#home legend[for="sounds"]').text(i18n.lang.options.soundsLabel+":");
		$('#home label[for="sounds"] .ui-btn-text').text(i18n.lang.options.sounds);
		$('#home legend[for="showBackgroundImage"]').text(i18n.lang.options.showBackgroundImageLabel+":");
		$('#home label[for="showBackgroundImage"] .ui-btn-text').text(i18n.lang.options.showBackgroundImage);
		$('#info div[data-role="content"]').html(i18n.lang.info.text+"<br/>"+i18n.lang.info.help);
		
		var aux=$('#home a[href="#ranking"] .ui-btn-text');
		if(aux.length)
			aux.text(i18n.lang.ranking);//Per si ja esta renderitzat
		else $('#home a[href="#ranking"]').text(i18n.lang.ranking);
		
		$(window).trigger('languageChange');
	};
	
	var pageBeforeShow=pageBeforeHide=function(){
		if(sounds.is(':checked')) slide.play();
	};
	
	var menuButton=function(){
		$.mobile.changePage("#home");
		$('#options').panel("open");
	};
	
	var resize=function(){
		//Corregimos el error de tamao cuando no se ejecuta desde el escritorio
		home.height($(window).height());
	};
	
	var commonReady=function(){
		pictURL.val(P2J.get("pictURL")||'images/default.jpg');
		pictURL.on('change',puzzleChange);
		sounds.attr('checked',P2J.get("sounds")=='play'||P2J.get("sounds")===null).checkboxradio().checkboxradio("refresh");
		sounds.on('change',configChange);
		showBackgroundImage.attr('checked',P2J.get("showBackgroundImage")=='show'||P2J.get("showBackgroundImage")===null).checkboxradio().checkboxradio("refresh");
		showBackgroundImage.on('change',configChange);
		rows.val(P2J.get("rows")||'2');
		rows.on('change',puzzleChange);
		cols.val(P2J.get("cols")||'2');
		cols.on('change',puzzleChange);
		rotations.val(P2J.get("rotations")||'0');
		rotations.on('change',puzzleChange);
		photo.on('vclick',makePhoto);
		gallery.on('vclick',selectPhoto);
		language.val(P2J.get("language")||'ca').selectmenu().selectmenu("refresh");
		language.on('change',languageChange);
		languageChange(language.val());
		configChange(null,true);
		puzzleChange(null,true);
		home.on('pagebeforeshow',pageBeforeShow);
		home.on('pagebeforehide',pageBeforeHide);
		if(!P2J.isDesktop){
			$(window).resize(resize);
			$('#home #info').panel({
				  close: resize
			});
		}
	};
	
	var deviceReady=function(){
		commonReady();
		$(document).on('menubutton',menuButton);
		$(document).on('searchbutton',selectPhoto);
		slide=new Media('/android_asset/www/sounds/slide.mp3',$.noop,$.noop);
	};
	
	var desktopReady=function(){
		commonReady();
		slide=new Audio('sounds/slide.mp3');
	};
	
	return {
		deviceReady:deviceReady,
		desktopReady:desktopReady
	}
};
