P2J.modules.ranking=function() {
	var ranking=$('#ranking');
	var table=$('#table');
	var tableBody=$('#table tbody');
	var rankingData=null;
	var typeName=$('#typeName');
	var playerName=$('#playerName');
	var newGame=false;
	
	var formatTime=function(time){
		var d=new Date(time);
		var hourStr=(d.getHours()>1)?'0'+(d.getHours()-1)+':':'';
		hourStr=hourStr?hourStr.substring(hourStr.length-3):'';
		var minStr='0'+d.getMinutes()+':';
		minStr=minStr.substring(minStr.length-3);
		var secStr='0'+d.getSeconds();
		secStr=secStr.substring(secStr.length-2);
		return hourStr+minStr+secStr;
	};
	
	var formatRotations=function(rotations){
		return rotations*100+"%";
	};
	
	var getPosition=function(data){
		var pos=!rankingData.length?0:-1;
		$.each(rankingData,function(i,item){
			if(data.size>item.size || (data.size==item.size && data.rotations>item.rotations)
				|| (data.size==item.size && data.rotations==item.rotations && data.time<item.time)){
				pos=i;
				return false;
			}
		})
		return pos;
	};
	
	var pageShow=function(){
		if(!rankingData) loadRankingData();
		if(newGame){
			if(getPosition(newGame)>-1) typeName.popup("open");
		}else refreshData();
		$('#ranking .ui-table-columntoggle-btn').removeClass('ui-mini');
	};

	var puzzleDone=function(event,data){
		newGame=data;
	};
	
	var languageChange=function(){
		var aux=$('#ranking a[href="#home"] .ui-btn-text');
		if(aux.length)
			aux.text(i18n.lang.home);//Per si ja esta renderitzat
		else $('#ranking a[href="#home"]').text(i18n.lang.home);
		
		table.attr('data-column-btn-text',i18n.lang.tableColumns.columns);
		$('#ranking a[href="#table-popup"] .ui-btn-text').text(i18n.lang.tableColumns.columns);
		var columns=$('#ranking #table th');
		columns[1].innerHTML=i18n.lang.tableColumns.player;
		columns[2].innerHTML=i18n.lang.tableColumns.size;
		columns[3].innerHTML=i18n.lang.tableColumns.rotations;
		columns[4].innerHTML=i18n.lang.tableColumns.time;
		aux=$('#ranking #table-popup-popup .ui-btn-text');
		if(aux.length){
			aux[0].innerHTML=i18n.lang.tableColumns.player;
			aux[1].innerHTML=i18n.lang.tableColumns.size;
			aux[2].innerHTML=i18n.lang.tableColumns.rotations;			
		}
		
		$('#typeName label').text(i18n.lang.typeName.label);
		var aux=$('#typeName a .ui-btn-text');
		if(aux.length){
			$(aux[0]).text(i18n.lang.typeName.cancel);
			$(aux[1]).text(i18n.lang.typeName.ok);
		}else{
			aux=$('#typeName a');
			$(aux[0]).text(i18n.lang.typeName.cancel);
			$(aux[1]).text(i18n.lang.typeName.ok);
		}
	};
	
	var loadRankingData=function(){
		//Format: {name:'AAAA',size:24,rotations:0,time:90000}
		rankingData=JSON.parse(P2J.get("rankingData")||"[]");
		return rankingData;
	};
	
	var refreshData=function(){
		tableBody.html('');
		$.each(rankingData,function(i,item){
			tableBody.append(
				'<tr><td>'+(i+1)+
				'</td><td class="ui-table-priority-3">'+item.name+
				'</td><td class="ui-table-priority-1">'+item.size+
				'</td><td class="ui-table-priority-2">'+formatRotations(item.rotations)+
				'</td><td>'+formatTime(item.time)+'</td></tr>'
			);
		})	
		table.table("refresh");
	};
	
	var playNameKeyPress=function (e){
        if(e.keyCode == 13){
			addNewGame();
			typeName.popup('close');
		}
	};
	
	var addNewGame=function(){
		newGame.name=playerName.val();
		P2J.set('playerName',newGame.name);
		//Guardarem els 5 primers
		rankingData.splice(getPosition(newGame),(rankingData.length>4)?1:0,newGame);
		P2J.set("rankingData",JSON.stringify(rankingData));
		newGame=false;
	};
	
	var commonReady=function(){
		ranking.on('pageshow',pageShow);
		$(window).on('puzzleDone',puzzleDone);
		$(window).on('languageChange',languageChange);
		typeName.on('popupafterclose',refreshData);
		playerName.on('keypress', playNameKeyPress);
		$('#typeNameOk').on('vclick',addNewGame);
		playerName.val(P2J.get('playerName')||'');
	};
	
	return {
		deviceReady:commonReady,
		desktopReady:commonReady,
		loadingRankingData:loadRankingData,
		addNewGame:addNewGame
	}
};
