TS.Home=function(){
	module( "HOME" );
	
	//Objectos de home
	var home=$('#home');
	var pictURL=$('#home #pictURL');
	var sounds=$('#home #sounds');
	var slide=null;
	var showBackgroundImage=$('#home #showBackgroundImage');
	var rows=$('#home #rows');
	var cols=$('#home #cols');
	var rotations=$('#home #rotations');
	var photo=$('#home #photo');
	var gallery=$('#home #gallery');
	var language=$('#home #language');
	
	//Objetos de puzzle
	var puzzleDone=$('#puzzleDone');
	
	//Objetos de ranking
	var table=$('#table');
	
	test("languageChange",44,function(){
		$(TS.window).on('languageChange',function(e){
			equal(language.val(),P2J.get("language"),'event languageChange executat OK');
		});
		
		language.triggerHandler('change');
		equal($('#home label[for="rows"]').text() , i18n.lang.rows+":" , 'language change - valor de "rows" OK');
		for(var i=2;i<11;i++) equal(rows[0].options[i-2].text,i+' '+i18n.lang.rows,'language change - valor de row['+(i-2)+'] OK');
		
		equal($('#home label[for="cols"]').text() , i18n.lang.cols+":" , 'language change - valor de "cols" OK');
		for(var i=2;i<11;i++) equal(cols[0].options[i-2].text,i+' '+i18n.lang.cols,'language change - valor de col['+(i-2)+'] OK');
		
		equal($('#home label[for="rotations"]').text() , i18n.lang.rotations.text+":" , 'language change - valor de "rotations" OK');
		for(var i=0;i<5;i++) equal(rotations[0].options[i].text , i18n.lang.rotations.options[i],'language change - valor de rotations['+i+'] OK');
		
		equal($('#home legend[for="language"]').text(), i18n.lang.options.language+":", 'language change - valor de "legend language" OK');
		equal($('#home legend[for="sounds"]').text(), i18n.lang.options.soundsLabel+":", 'language change - valor de "legend sounds" OK');
		equal($('#home label[for="sounds"] .ui-btn-text').text(), i18n.lang.options.sounds, 'language change - valor de "label sounds" OK');
		equal($('#home legend[for="showBackgroundImage"]').text(), i18n.lang.options.showBackgroundImageLabel+":", 'language change - valor de "legend showBackgroundImage" OK');
		equal($('#home label[for="showBackgroundImage"] .ui-btn-text').text(), i18n.lang.options.showBackgroundImage, 'language change - valor de "label showBackgroundImage" OK');
		equal($('#info div[data-role="content"]').html(), i18n.lang.info.text+"<br>"+i18n.lang.info.help, 'language change - valor de info OK');
		
		equal($('#home a[href="#ranking"] .ui-btn-text').text(), i18n.lang.ranking, 'language change - valor de ranking OK');//Per si ja esta renderitzat
		
		//puzzle
		equal(puzzleDone.text() , i18n.lang.puzzleDone , 'language change - valor de puzzleDone OK');
		
		//ranking
		equal($('#ranking a[href="#home"]').text(),i18n.lang.home,'language change - valor de ranking home OK');
		equal(table.attr('data-column-btn-text'),i18n.lang.tableColumns.columns,'language change - valor de tableColumns OK');
		
		var columns=$('#ranking #table th');
		equal(columns[1].innerHTML,i18n.lang.tableColumns.player,'language change - valor de tableColumns.player OK');
		equal(columns[2].innerHTML,i18n.lang.tableColumns.size,'language change - valor de tableColumns.size OK');
		equal(columns[3].innerHTML,i18n.lang.tableColumns.rotations,'language change - valor de tableColumns.rotations OK');
		equal(columns[4].innerHTML,i18n.lang.tableColumns.time,'language change - valor de tableColumns.time OK');

		equal($('#typeName label').text(),i18n.lang.typeName.label,'language change - valor de typeName label OK');
		var aux=$('#typeName a');
		equal($(aux[0]).text(),i18n.lang.typeName.cancel,'language change - valor de typeName a.cancel OK');
		equal($(aux[1]).text(),i18n.lang.typeName.ok,'language change - valor de typeName a.ok OK');

	});
	
	test("configChange",6,function(){
		$(TS.window).on('configChange',function(e){
			deepEqual({
				sounds : e.handleObj.handler.arguments[1].sounds,
				showBackgroundImage : e.handleObj.handler.arguments[1].showBackgroundImage,
			},{
				sounds : sounds.is(':checked'),
				showBackgroundImage : showBackgroundImage.is(':checked')
			},'event configChange executat OK');
		});
		
		sounds.triggerHandler('change');
		equal(P2J.get("sounds") , sounds.is(':checked')?sounds.val():'' , 'sounds change - valor de "sounds" OK');
		equal(P2J.get("showBackgroundImage") , showBackgroundImage.is(':checked')?showBackgroundImage.val():'' , 'sounds change - valor de "showBackgroundImage" OK');
		
		sounds.triggerHandler('change');
		equal(P2J.get("sounds") , sounds.is(':checked')?sounds.val():'' , 'showBackgroundImage change - valor de "sounds" OK');
		equal(P2J.get("showBackgroundImage") , showBackgroundImage.is(':checked')?showBackgroundImage.val():'' , 'showBackgroundImage change - valor de "showBackgroundImage" OK');
	});
	
	test("puzzleChange",20,function(){
		$(TS.window).on('puzzleChange',function(e){
			deepEqual({
				pictURL : e.handleObj.handler.arguments[1].pictURL,
				rows : e.handleObj.handler.arguments[1].rows,
				cols : e.handleObj.handler.arguments[1].cols,
				rotations : e.handleObj.handler.arguments[1].rotations
			},{
				pictURL : pictURL.val(),
				rows : rows.val(),
				cols : cols.val(),
				rotations : rotations.val()
			},'event puzzleChange executat OK');
		});
		
		pictURL.triggerHandler('change');
		equal(P2J.get("pictURL") , pictURL.val(), 'pictURL change - valor de "pictURL" OK');
		equal(P2J.get("rows") , rows.val(), 'pictURL change - valor de "rows" OK');
		equal(P2J.get("cols") , cols.val(), 'pictURL change - valor de "cols" OK');
		equal(P2J.get("rotations") , rotations.val(), 'pictURL change - valor de "rotations" OK');

		rows.triggerHandler('change');
		equal(P2J.get("pictURL") , pictURL.val(), 'rows change - valor de "pictURL" OK');
		equal(P2J.get("rows") , rows.val(), 'rows change - valor de "rows" OK');
		equal(P2J.get("cols") , cols.val(), 'rows change - valor de "cols" OK');
		equal(P2J.get("rotations") , rotations.val(), 'rows change - valor de "rotations" OK');

		cols.triggerHandler('change');
		equal(P2J.get("pictURL") , pictURL.val(), 'cols change - valor de "pictURL" OK');
		equal(P2J.get("rows") , rows.val(), 'cols change - valor de "rows" OK');
		equal(P2J.get("cols") , cols.val(), 'cols change - valor de "cols" OK');
		equal(P2J.get("rotations") , rotations.val(), 'cols change - valor de "rotations" OK');

		rotations.triggerHandler('change');
		equal(P2J.get("pictURL") , pictURL.val(), 'rotations change - valor de "pictURL" OK');
		equal(P2J.get("rows") , rows.val(), 'rotations change - valor de "rows" OK');
		equal(P2J.get("cols") , cols.val(), 'rotations change - valor de "cols" OK');
		equal(P2J.get("rotations") , rotations.val(), 'rotations change - valor de "rotations" OK');
		
	})
};